
/*
* Copyright (C) 2004-2014 Texas Instruments Incorporated - http://www.ti.com/
* All rights reserved.	
*
*  Redistribution and use in source and binary forms, with or without
*  modification, are permitted provided that the following conditions
*  are met:
*
*    Redistributions of source code must retain the above copyright
*    notice, this list of conditions and the following disclaimer.
*
*    Redistributions in binary form must reproduce the above copyright
*    notice, this list of conditions and the following disclaimer in the
*    documentation and/or other materials provided with the
*    distribution.
*
*    Neither the name of Texas Instruments Incorporated nor the names of
*    its contributors may be used to endorse or promote products derived
*    from this software without specific prior written permission.
*
*  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
*  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
*  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
*  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
*  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
*  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
*  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
*  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
*  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
*  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
*  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*
*/

#ifndef _CSLR__SEC_CTL_202_H_
#define _CSLR__SEC_CTL_202_H_

#include <cslr.h>

#include <tistdtypes.h>

/* Minimum unit = 1 byte */

/**************************************************************************\
* Register Overlay Structure
\**************************************************************************/
typedef struct  {
    volatile Uint32 PID;
    volatile Uint8 RSVD0[12];
    volatile Uint32 SYSSTATUS;
    volatile Uint32 SYSWR;
    volatile Uint8 RSVD1[4];
    volatile Uint32 ARMWR;
    volatile Uint32 SYSCONTROL;
    volatile Uint32 SYSCONTROLPROTECT;
    volatile Uint32 SYSTAPEN;
    volatile Uint32 SECRESERVED;
    volatile Uint32 PSTATUS;
    volatile Uint32 PREADDEBUGDAT;
    volatile Uint32 PWRITEDEBUGDAT;
} CSL_ScRegs;

/**************************************************************************\
* Field Definition Macros
\**************************************************************************/

/* PID */

#define CSL_SEC_CTL_PID_SCHEME_MASK (0xC0000000u)
#define CSL_SEC_CTL_PID_SCHEME_SHIFT (0x0000001Eu)
#define CSL_SEC_CTL_PID_SCHEME_RESETVAL (0x00000001u)


#define CSL_SEC_CTL_PID_FUNC_MASK (0x0FFF0000u)
#define CSL_SEC_CTL_PID_FUNC_SHIFT (0x00000010u)
#define CSL_SEC_CTL_PID_FUNC_RESETVAL (0x00000484u)

#define CSL_SEC_CTL_PID_RTL_MASK (0x0000F800u)
#define CSL_SEC_CTL_PID_RTL_SHIFT (0x0000000Bu)
#define CSL_SEC_CTL_PID_RTL_RESETVAL (0x00000000u)

#define CSL_SEC_CTL_PID_MAJOR_MASK (0x00000700u)
#define CSL_SEC_CTL_PID_MAJOR_SHIFT (0x00000008u)
#define CSL_SEC_CTL_PID_MAJOR_RESETVAL (0x00000002u)

#define CSL_SEC_CTL_PID_CUSTOM_MASK (0x000000C0u)
#define CSL_SEC_CTL_PID_CUSTOM_SHIFT (0x00000006u)
#define CSL_SEC_CTL_PID_CUSTOM_RESETVAL (0x00000000u)

#define CSL_SEC_CTL_PID_MINOR_MASK (0x0000003Fu)
#define CSL_SEC_CTL_PID_MINOR_SHIFT (0x00000000u)
#define CSL_SEC_CTL_PID_MINOR_RESETVAL (0x00000000u)

#define CSL_SEC_CTL_PID_RESETVAL (0x44840200u)

/* SYSSTATUS */

#define CSL_SEC_CTL_SYSSTATUS_SEC_ENC_MASK (0xFF000000u)
#define CSL_SEC_CTL_SYSSTATUS_SEC_ENC_SHIFT (0x00000018u)
#define CSL_SEC_CTL_SYSSTATUS_SEC_ENC_RESETVAL (0x00000000u)

#define CSL_SEC_CTL_SYSSTATUS_RSVD_MASK (0x00F00000u)
#define CSL_SEC_CTL_SYSSTATUS_RSVD_SHIFT (0x00000014u)
#define CSL_SEC_CTL_SYSSTATUS_RSVD_RESETVAL (0x00000000u)

#define CSL_SEC_CTL_SYSSTATUS_TAP_EN_MASK (0x00080000u)
#define CSL_SEC_CTL_SYSSTATUS_TAP_EN_SHIFT (0x00000013u)
#define CSL_SEC_CTL_SYSSTATUS_TAP_EN_RESETVAL (0x00000000u)
#define CSL_SEC_CTL_SYSSTATUS_TAP_EN_RNW (0x00000000u)
#define CSL_SEC_CTL_SYSSTATUS_TAP_EN_RW (0x00000001u)

#define CSL_SEC_CTL_SYSSTATUS_ARM_REG_MASK (0x00040000u)
#define CSL_SEC_CTL_SYSSTATUS_ARM_REG_SHIFT (0x00000012u)
#define CSL_SEC_CTL_SYSSTATUS_ARM_REG_RESETVAL (0x00000000u)
#define CSL_SEC_CTL_SYSSTATUS_ARM_REG_RNW (0x00000000u)
#define CSL_SEC_CTL_SYSSTATUS_ARM_REG_RW (0x00000001u)


#define CSL_SEC_CTL_SYSSTATUS_SYS_REG_MASK (0x00010000u)
#define CSL_SEC_CTL_SYSSTATUS_SYS_REG_SHIFT (0x00000010u)
#define CSL_SEC_CTL_SYSSTATUS_SYS_REG_RESETVAL (0x00000000u)
#define CSL_SEC_CTL_SYSSTATUS_SYS_REG_RNW (0x00000000u)
#define CSL_SEC_CTL_SYSSTATUS_SYS_REG_RW (0x00000001u)


#define CSL_SEC_CTL_SYSSTATUS_SEC_ROM_PASS_MASK (0x00000800u)
#define CSL_SEC_CTL_SYSSTATUS_SEC_ROM_PASS_SHIFT (0x0000000Bu)
#define CSL_SEC_CTL_SYSSTATUS_SEC_ROM_PASS_RESETVAL (0x00000000u)

#define CSL_SEC_CTL_SYSSTATUS_SEC_ROM_DONE_MASK (0x00000400u)
#define CSL_SEC_CTL_SYSSTATUS_SEC_ROM_DONE_SHIFT (0x0000000Au)
#define CSL_SEC_CTL_SYSSTATUS_SEC_ROM_DONE_RESETVAL (0x00000000u)

#define CSL_SEC_CTL_SYSSTATUS_CHKSUM_PASS_MASK (0x00000200u)
#define CSL_SEC_CTL_SYSSTATUS_CHKSUM_PASS_SHIFT (0x00000009u)
#define CSL_SEC_CTL_SYSSTATUS_CHKSUM_PASS_RESETVAL (0x00000000u)
#define CSL_SEC_CTL_SYSSTATUS_CHKSUM_PASS_CSND (0x00000000u)
#define CSL_SEC_CTL_SYSSTATUS_CHKSUM_PASS_CSD (0x00000001u)

#define CSL_SEC_CTL_SYSSTATUS_CHKSUM_DONE_MASK (0x00000100u)
#define CSL_SEC_CTL_SYSSTATUS_CHKSUM_DONE_SHIFT (0x00000008u)
#define CSL_SEC_CTL_SYSSTATUS_CHKSUM_DONE_RESETVAL (0x00000000u)

#define CSL_SEC_CTL_SYSSTATUS_MMR_UNLOCK_MASK (0x00000080u)
#define CSL_SEC_CTL_SYSSTATUS_MMR_UNLOCK_SHIFT (0x00000007u)
#define CSL_SEC_CTL_SYSSTATUS_MMR_UNLOCK_RESETVAL (0x00000000u)

#define CSL_SEC_CTL_SYSSTATUS_MMR_LOCK_MASK (0x00000040u)
#define CSL_SEC_CTL_SYSSTATUS_MMR_LOCK_SHIFT (0x00000006u)
#define CSL_SEC_CTL_SYSSTATUS_MMR_LOCK_RESETVAL (0x00000000u)

#define CSL_SEC_CTL_SYSSTATUS_SEC_OVERRIDE_MASK (0x00000020u)
#define CSL_SEC_CTL_SYSSTATUS_SEC_OVERRIDE_SHIFT (0x00000005u)
#define CSL_SEC_CTL_SYSSTATUS_SEC_OVERRIDE_RESETVAL (0x00000000u)

#define CSL_SEC_CTL_SYSSTATUS_TEST_SEC_MASK (0x00000010u)
#define CSL_SEC_CTL_SYSSTATUS_TEST_SEC_SHIFT (0x00000004u)
#define CSL_SEC_CTL_SYSSTATUS_TEST_SEC_RESETVAL (0x00000000u)

#define CSL_SEC_CTL_SYSSTATUS_TEST_NONSEC_MASK (0x00000008u)
#define CSL_SEC_CTL_SYSSTATUS_TEST_NONSEC_SHIFT (0x00000003u)
#define CSL_SEC_CTL_SYSSTATUS_TEST_NONSEC_RESETVAL (0x00000000u)

#define CSL_SEC_CTL_SYSSTATUS_DEVICE_MASK (0x00000007u)
#define CSL_SEC_CTL_SYSSTATUS_DEVICE_SHIFT (0x00000000u)
#define CSL_SEC_CTL_SYSSTATUS_DEVICE_RESETVAL (0x00000000u)
#define CSL_SEC_CTL_SYSSTATUS_DEVICE_TEST (0x00000000u)
#define CSL_SEC_CTL_SYSSTATUS_DEVICE_BAD (0x00000001u)

#define CSL_SEC_CTL_SYSSTATUS_RESETVAL (0x00000000u)

/* SYSWR */

#define CSL_SEC_CTL_SYSWR_RSVD_MASK (0xFFFFFC00u)
#define CSL_SEC_CTL_SYSWR_RSVD_SHIFT (0x0000000Au)
#define CSL_SEC_CTL_SYSWR_RSVD_RESETVAL (0x00000000u)

#define CSL_SEC_CTL_SYSWR_SEC_ROM_PASS_MASK (0x00000200u)
#define CSL_SEC_CTL_SYSWR_SEC_ROM_PASS_SHIFT (0x00000009u)
#define CSL_SEC_CTL_SYSWR_SEC_ROM_PASS_RESETVAL (0x00000000u)
#define CSL_SEC_CTL_SYSWR_SEC_ROM_PASS_FAIL (0x00000000u)
#define CSL_SEC_CTL_SYSWR_SEC_ROM_PASS_PASS (0x00000001u)

#define CSL_SEC_CTL_SYSWR_SEC_ROM_DONE_MASK (0x00000100u)
#define CSL_SEC_CTL_SYSWR_SEC_ROM_DONE_SHIFT (0x00000008u)
#define CSL_SEC_CTL_SYSWR_SEC_ROM_DONE_RESETVAL (0x00000000u)
#define CSL_SEC_CTL_SYSWR_SEC_ROM_DONE_NOT_DONE (0x00000000u)
#define CSL_SEC_CTL_SYSWR_SEC_ROM_DONE_DONE (0x00000001u)


#define CSL_SEC_CTL_SYSWR_SEC_OVR_MASK (0x00000001u)
#define CSL_SEC_CTL_SYSWR_SEC_OVR_SHIFT (0x00000000u)
#define CSL_SEC_CTL_SYSWR_SEC_OVR_RESETVAL (0x00000000u)
#define CSL_SEC_CTL_SYSWR_SEC_OVR_NO_SEC_OVR (0x00000000u)
#define CSL_SEC_CTL_SYSWR_SEC_OVR_SEC_OVR (0x00000001u)

#define CSL_SEC_CTL_SYSWR_RESETVAL (0x00000000u)

/* ARMWR */


#define CSL_SEC_CTL_ARMWR_CP15S_DISABLE_MASK (0x00000001u)
#define CSL_SEC_CTL_ARMWR_CP15S_DISABLE_SHIFT (0x00000000u)
#define CSL_SEC_CTL_ARMWR_CP15S_DISABLE_RESETVAL (0x00000000u)
#define CSL_SEC_CTL_ARMWR_CP15S_DISABLE_PASS (0x00000000u)
#define CSL_SEC_CTL_ARMWR_CP15S_DISABLE_FAIL (0x00000001u)

#define CSL_SEC_CTL_ARMWR_RESETVAL (0x00000000u)

/* SYSCONTROL */


#define CSL_SEC_CTL_SYSCONTROL_SRAM_N_CACHE_MASK (0x00010000u)
#define CSL_SEC_CTL_SYSCONTROL_SRAM_N_CACHE_SHIFT (0x00000010u)
#define CSL_SEC_CTL_SYSCONTROL_SRAM_N_CACHE_RESETVAL (0x00000000u)


#define CSL_SEC_CTL_SYSCONTROL_SEC_MMR_REQ_MASK (0x00000100u)
#define CSL_SEC_CTL_SYSCONTROL_SEC_MMR_REQ_SHIFT (0x00000008u)
#define CSL_SEC_CTL_SYSCONTROL_SEC_MMR_REQ_RESETVAL (0x00000000u)


#define CSL_SEC_CTL_SYSCONTROL_SEC_UPDATE_MASK (0x00000001u)
#define CSL_SEC_CTL_SYSCONTROL_SEC_UPDATE_SHIFT (0x00000000u)
#define CSL_SEC_CTL_SYSCONTROL_SEC_UPDATE_RESETVAL (0x00000000u)

#define CSL_SEC_CTL_SYSCONTROL_RESETVAL (0x00000000u)

/* SYSCONTROLPROTECT */


#define CSL_SEC_CTL_SYSCONTROLPROTECT_MMR_UNLOCK_MASK (0x00020000u)
#define CSL_SEC_CTL_SYSCONTROLPROTECT_MMR_UNLOCK_SHIFT (0x00000011u)
#define CSL_SEC_CTL_SYSCONTROLPROTECT_MMR_UNLOCK_RESETVAL (0x00000000u)
#define CSL_SEC_CTL_SYSCONTROLPROTECT_MMR_UNLOCK_MMR_LOCK (0x00000000u)
#define CSL_SEC_CTL_SYSCONTROLPROTECT_MMR_UNLOCK_MMR_UNLOCK (0x00000001u)

#define CSL_SEC_CTL_SYSCONTROLPROTECT_MMR_LOCK_MASK (0x00010000u)
#define CSL_SEC_CTL_SYSCONTROLPROTECT_MMR_LOCK_SHIFT (0x00000010u)
#define CSL_SEC_CTL_SYSCONTROLPROTECT_MMR_LOCK_RESETVAL (0x00000000u)
#define CSL_SEC_CTL_SYSCONTROLPROTECT_MMR_LOCK_MMR_UNLOCK (0x00000000u)
#define CSL_SEC_CTL_SYSCONTROLPROTECT_MMR_LOCK_MMR_LOCK (0x00000001u)


#define CSL_SEC_CTL_SYSCONTROLPROTECT_SEC_EN_CTL_MASK (0x000000FFu)
#define CSL_SEC_CTL_SYSCONTROLPROTECT_SEC_EN_CTL_SHIFT (0x00000000u)
#define CSL_SEC_CTL_SYSCONTROLPROTECT_SEC_EN_CTL_RESETVAL (0x00000000u)

#define CSL_SEC_CTL_SYSCONTROLPROTECT_RESETVAL (0x00000000u)

/* SYSTAPEN */

#define CSL_SEC_CTL_SYSTAPEN_TEST_TAP_EN_MASK (0xFFFF0000u)
#define CSL_SEC_CTL_SYSTAPEN_TEST_TAP_EN_SHIFT (0x00000010u)
#define CSL_SEC_CTL_SYSTAPEN_TEST_TAP_EN_RESETVAL (0x00000000u)

#define CSL_SEC_CTL_SYSTAPEN_DBG_TAP_EN_MASK (0x0000FFFFu)
#define CSL_SEC_CTL_SYSTAPEN_DBG_TAP_EN_SHIFT (0x00000000u)
#define CSL_SEC_CTL_SYSTAPEN_DBG_TAP_EN_RESETVAL (0x00000000u)

#define CSL_SEC_CTL_SYSTAPEN_RESETVAL (0x00000000u)

/* SECRESERVED */


#define CSL_SEC_CTL_SECRESERVED_SEC_RSVD_MASK (0x00FFFFFFu)
#define CSL_SEC_CTL_SECRESERVED_SEC_RSVD_SHIFT (0x00000000u)
#define CSL_SEC_CTL_SECRESERVED_SEC_RSVD_RESETVAL (0x00000000u)

#define CSL_SEC_CTL_SECRESERVED_RESETVAL (0x00000000u)

/* PSTATUS */



#define CSL_SEC_CTL_PSTATUS_CHKSUM_PASS_MASK (0x00000100u)
#define CSL_SEC_CTL_PSTATUS_CHKSUM_PASS_SHIFT (0x00000008u)
#define CSL_SEC_CTL_PSTATUS_CHKSUM_PASS_RESETVAL (0x00000000u)

#define CSL_SEC_CTL_PSTATUS_CHKSUM_DONE_MASK (0x00000080u)
#define CSL_SEC_CTL_PSTATUS_CHKSUM_DONE_SHIFT (0x00000007u)
#define CSL_SEC_CTL_PSTATUS_CHKSUM_DONE_RESETVAL (0x00000000u)

#define CSL_SEC_CTL_PSTATUS_SEC_ROM_PASS_MASK (0x00000040u)
#define CSL_SEC_CTL_PSTATUS_SEC_ROM_PASS_SHIFT (0x00000006u)
#define CSL_SEC_CTL_PSTATUS_SEC_ROM_PASS_RESETVAL (0x00000000u)

#define CSL_SEC_CTL_PSTATUS_SEC_ROM_DONE_MASK (0x00000020u)
#define CSL_SEC_CTL_PSTATUS_SEC_ROM_DONE_SHIFT (0x00000005u)
#define CSL_SEC_CTL_PSTATUS_SEC_ROM_DONE_RESETVAL (0x00000000u)

#define CSL_SEC_CTL_PSTATUS_TEST_SEC_MASK (0x00000010u)
#define CSL_SEC_CTL_PSTATUS_TEST_SEC_SHIFT (0x00000004u)
#define CSL_SEC_CTL_PSTATUS_TEST_SEC_RESETVAL (0x00000000u)

#define CSL_SEC_CTL_PSTATUS_TEST_NONSEC_MASK (0x00000008u)
#define CSL_SEC_CTL_PSTATUS_TEST_NONSEC_SHIFT (0x00000003u)
#define CSL_SEC_CTL_PSTATUS_TEST_NONSEC_RESETVAL (0x00000000u)

#define CSL_SEC_CTL_PSTATUS_DEVICE_MASK (0x00000007u)
#define CSL_SEC_CTL_PSTATUS_DEVICE_SHIFT (0x00000000u)
#define CSL_SEC_CTL_PSTATUS_DEVICE_RESETVAL (0x00000000u)
#define CSL_SEC_CTL_PSTATUS_DEVICE_TEST (0x00000000u)
#define CSL_SEC_CTL_PSTATUS_DEVICE_SECURE (0x00000002u)
#define CSL_SEC_CTL_PSTATUS_DEVICE_NONSECURE (0x00000003u)
#define CSL_SEC_CTL_PSTATUS_DEVICE_BAD (0x00000001u)

#define CSL_SEC_CTL_PSTATUS_RESETVAL (0x00000000u)

/* PREADDEBUGDAT */

#define CSL_SEC_CTL_PREADDEBUGDAT_DEBUG_MASK (0xFFFFFFFFu)
#define CSL_SEC_CTL_PREADDEBUGDAT_DEBUG_SHIFT (0x00000000u)
#define CSL_SEC_CTL_PREADDEBUGDAT_DEBUG_RESETVAL (0x00000000u)

#define CSL_SEC_CTL_PREADDEBUGDAT_RESETVAL (0x00000000u)

/* PWRITEDEBUGDAT */

#define CSL_SEC_CTL_PWRITEDEBUGDAT_DEBUG_MASK (0xFFFFFFFFu)
#define CSL_SEC_CTL_PWRITEDEBUGDAT_DEBUG_SHIFT (0x00000000u)
#define CSL_SEC_CTL_PWRITEDEBUGDAT_DEBUG_RESETVAL (0x00000000u)

#define CSL_SEC_CTL_PWRITEDEBUGDAT_RESETVAL (0x00000000u)

#endif
